"""
    Best Execution Analytics for Smarter Trading (BEAST) API

    Enables clients to programmatically access the underlying data which powers the BEAST Liquidity Analytics (LA) and Transaction Cost Analysis (TCA) applications.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from multiprocessing.pool import ApplyResult
import typing

from fds.sdk.BestExecutionAnalyticsforSmarterTradingBEAST.api_client import ApiClient, Endpoint as _Endpoint
from fds.sdk.BestExecutionAnalyticsforSmarterTradingBEAST.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from fds.sdk.BestExecutionAnalyticsforSmarterTradingBEAST.exceptions import ApiException
from fds.sdk.BestExecutionAnalyticsforSmarterTradingBEAST.model.error_response import ErrorResponse
from fds.sdk.BestExecutionAnalyticsforSmarterTradingBEAST.model.outlier_response_root import OutlierResponseRoot





class OutliersApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        self.get_outlier_metrics_by_percentile_endpoint = _Endpoint(
            settings={
                'response_type': (
                  { 200: (OutlierResponseRoot,), 400: (ErrorResponse,),  },
                  None
                ),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/tca/outlier/metrics-by-percentile',
                'operation_id': 'get_outlier_metrics_by_percentile',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'metric_type',
                    'start_date',
                    'end_date',
                    'region',
                    'trader',
                    'min_percent',
                    'max_percent',
                    'bin_scalar',
                ],
                'required': [
                    'metric_type',
                    'start_date',
                    'end_date',
                ],
                'nullable': [
                ],
                'enum': [
                    'metric_type',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('metric_type',): {

                        "FIRSTFILLMIDPERFBPS": "firstFillMidPerfBps",
                        "LASTFILLMIDPERFBPS": "lastFillMidPerfBps",
                        "OPENPERFBPS": "openPerfBps",
                        "CLOSEPERFBPS": "closePerfBps",
                        "VWAPFFLFPERFBPS": "vwapFfLfPerfBps",
                        "REVERSION5MINMIDBPS": "reversion5MinMidBps",
                        "REVERSION10MINMIDBPS": "reversion10MinMidBps",
                        "REVERSION15MINMIDBPS": "reversion15MinMidBps",
                        "REVERSION60MINMIDBPS": "reversion60MinMidBps",
                        "PWP100PERFBPS": "pwp100PerfBps",
                        "PWP50PERFBPS": "pwp50PerfBps",
                        "PWP20PERFBPS": "pwp20PerfBps",
                        "PWP10PERFBPS": "pwp10PerfBps",
                        "PWP05PERFBPS": "pwp05PerfBps",
                        "PWP03PERFBPS": "pwp03PerfBps",
                        "PWP02PERFBPS": "pwp02PerfBps",
                        "PWP01PERFBPS": "pwp01PerfBps"
                    },
                },
                'openapi_types': {
                    'metric_type':
                        (str,),
                    'start_date':
                        (str,),
                    'end_date':
                        (str,),
                    'region':
                        (str,),
                    'trader':
                        (str,),
                    'min_percent':
                        (float,),
                    'max_percent':
                        (float,),
                    'bin_scalar':
                        (int,),
                },
                'attribute_map': {
                    'metric_type': 'metricType',
                    'start_date': 'startDate',
                    'end_date': 'endDate',
                    'region': 'region',
                    'trader': 'trader',
                    'min_percent': 'minPercent',
                    'max_percent': 'maxPercent',
                    'bin_scalar': 'binScalar',
                },
                'location_map': {
                    'metric_type': 'query',
                    'start_date': 'query',
                    'end_date': 'query',
                    'region': 'query',
                    'trader': 'query',
                    'min_percent': 'query',
                    'max_percent': 'query',
                    'bin_scalar': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

        self.get_outlier_metrics_standard_endpoint = _Endpoint(
            settings={
                'response_type': (
                  { 200: (OutlierResponseRoot,), 400: (ErrorResponse,),  },
                  None
                ),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/tca/outlier/metrics-standard',
                'operation_id': 'get_outlier_metrics_standard',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'metric_type',
                    'start_date',
                    'end_date',
                    'region',
                    'trader',
                    'deviation',
                    'bin_scalar',
                ],
                'required': [
                    'metric_type',
                    'start_date',
                    'end_date',
                ],
                'nullable': [
                ],
                'enum': [
                    'metric_type',
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                    ('metric_type',): {

                        "FIRSTFILLMIDPERFBPS": "firstFillMidPerfBps",
                        "LASTFILLMIDPERFBPS": "lastFillMidPerfBps",
                        "OPENPERFBPS": "openPerfBps",
                        "CLOSEPERFBPS": "closePerfBps",
                        "VWAPFFLFPERFBPS": "vwapFfLfPerfBps",
                        "REVERSION5MINMIDBPS": "reversion5MinMidBps",
                        "REVERSION10MINMIDBPS": "reversion10MinMidBps",
                        "REVERSION15MINMIDBPS": "reversion15MinMidBps",
                        "REVERSION60MINMIDBPS": "reversion60MinMidBps",
                        "PWP100PERFBPS": "pwp100PerfBps",
                        "PWP50PERFBPS": "pwp50PerfBps",
                        "PWP20PERFBPS": "pwp20PerfBps",
                        "PWP10PERFBPS": "pwp10PerfBps",
                        "PWP05PERFBPS": "pwp05PerfBps",
                        "PWP03PERFBPS": "pwp03PerfBps",
                        "PWP02PERFBPS": "pwp02PerfBps",
                        "PWP01PERFBPS": "pwp01PerfBps"
                    },
                },
                'openapi_types': {
                    'metric_type':
                        (str,),
                    'start_date':
                        (str,),
                    'end_date':
                        (str,),
                    'region':
                        (str,),
                    'trader':
                        (str,),
                    'deviation':
                        (float,),
                    'bin_scalar':
                        (int,),
                },
                'attribute_map': {
                    'metric_type': 'metricType',
                    'start_date': 'startDate',
                    'end_date': 'endDate',
                    'region': 'region',
                    'trader': 'trader',
                    'deviation': 'deviation',
                    'bin_scalar': 'binScalar',
                },
                'location_map': {
                    'metric_type': 'query',
                    'start_date': 'query',
                    'end_date': 'query',
                    'region': 'query',
                    'trader': 'query',
                    'deviation': 'query',
                    'bin_scalar': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )


    @staticmethod
    def apply_kwargs_defaults(kwargs, return_http_data_only, async_req):
        kwargs["async_req"] = async_req
        kwargs["_return_http_data_only"] = return_http_data_only
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")


    def get_outlier_metrics_by_percentile(
        self,
        metric_type,
        start_date,
        end_date,
        **kwargs
    ) -> OutlierResponseRoot:
        """Get Outlier Metrics by percentile  # noqa: E501

        Get outlier metrics by the specified metric type, percentile and date range  # noqa: E501
        This method makes a synchronous HTTP request. Returns the http data only

        Args:
            metric_type (str): Metric type
            start_date (str): Start date in the format YYYY-MM-DD
            end_date (str): End date in the format YYYY-MM-DD

        Keyword Args:
            region (str): The two character ISO country code of the trading region. EMEA is used for the European trading region. [optional]
            trader (str): Optionally specify a trader to filter by, Example : Ryan. [optional]
            min_percent (float): Min Percentile. [optional] if omitted the server will use the default value of 2.5
            max_percent (float): Max Percentile. [optional] if omitted the server will use the default value of 97.5
            bin_scalar (int): Bin Scalar. [optional] if omitted the server will use the default value of 51
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            OutlierResponseRoot
                Response Object
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=False)
        kwargs['metric_type'] = \
            metric_type
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.get_outlier_metrics_by_percentile_endpoint.call_with_http_info(**kwargs)

    def get_outlier_metrics_by_percentile_with_http_info(
        self,
        metric_type,
        start_date,
        end_date,
        **kwargs
    ) -> typing.Tuple[OutlierResponseRoot, int, typing.MutableMapping]:
        """Get Outlier Metrics by percentile  # noqa: E501

        Get outlier metrics by the specified metric type, percentile and date range  # noqa: E501
        This method makes a synchronous HTTP request. Returns http data, http status and headers

        Args:
            metric_type (str): Metric type
            start_date (str): Start date in the format YYYY-MM-DD
            end_date (str): End date in the format YYYY-MM-DD

        Keyword Args:
            region (str): The two character ISO country code of the trading region. EMEA is used for the European trading region. [optional]
            trader (str): Optionally specify a trader to filter by, Example : Ryan. [optional]
            min_percent (float): Min Percentile. [optional] if omitted the server will use the default value of 2.5
            max_percent (float): Max Percentile. [optional] if omitted the server will use the default value of 97.5
            bin_scalar (int): Bin Scalar. [optional] if omitted the server will use the default value of 51
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            OutlierResponseRoot
                Response Object
            int
                Http Status Code
            dict
                Dictionary of the response headers
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=False)
        kwargs['metric_type'] = \
            metric_type
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.get_outlier_metrics_by_percentile_endpoint.call_with_http_info(**kwargs)

    def get_outlier_metrics_by_percentile_async(
        self,
        metric_type,
        start_date,
        end_date,
        **kwargs
    ) -> "ApplyResult[OutlierResponseRoot]":
        """Get Outlier Metrics by percentile  # noqa: E501

        Get outlier metrics by the specified metric type, percentile and date range  # noqa: E501
        This method makes a asynchronous HTTP request. Returns the http data, wrapped in ApplyResult

        Args:
            metric_type (str): Metric type
            start_date (str): Start date in the format YYYY-MM-DD
            end_date (str): End date in the format YYYY-MM-DD

        Keyword Args:
            region (str): The two character ISO country code of the trading region. EMEA is used for the European trading region. [optional]
            trader (str): Optionally specify a trader to filter by, Example : Ryan. [optional]
            min_percent (float): Min Percentile. [optional] if omitted the server will use the default value of 2.5
            max_percent (float): Max Percentile. [optional] if omitted the server will use the default value of 97.5
            bin_scalar (int): Bin Scalar. [optional] if omitted the server will use the default value of 51
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[OutlierResponseRoot]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=True)
        kwargs['metric_type'] = \
            metric_type
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.get_outlier_metrics_by_percentile_endpoint.call_with_http_info(**kwargs)

    def get_outlier_metrics_by_percentile_with_http_info_async(
        self,
        metric_type,
        start_date,
        end_date,
        **kwargs
    ) -> "ApplyResult[typing.Tuple[OutlierResponseRoot, int, typing.MutableMapping]]":
        """Get Outlier Metrics by percentile  # noqa: E501

        Get outlier metrics by the specified metric type, percentile and date range  # noqa: E501
        This method makes a asynchronous HTTP request. Returns http data, http status and headers, wrapped in ApplyResult

        Args:
            metric_type (str): Metric type
            start_date (str): Start date in the format YYYY-MM-DD
            end_date (str): End date in the format YYYY-MM-DD

        Keyword Args:
            region (str): The two character ISO country code of the trading region. EMEA is used for the European trading region. [optional]
            trader (str): Optionally specify a trader to filter by, Example : Ryan. [optional]
            min_percent (float): Min Percentile. [optional] if omitted the server will use the default value of 2.5
            max_percent (float): Max Percentile. [optional] if omitted the server will use the default value of 97.5
            bin_scalar (int): Bin Scalar. [optional] if omitted the server will use the default value of 51
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[(OutlierResponseRoot, int, typing.Dict)]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=True)
        kwargs['metric_type'] = \
            metric_type
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.get_outlier_metrics_by_percentile_endpoint.call_with_http_info(**kwargs)


    def get_outlier_metrics_standard(
        self,
        metric_type,
        start_date,
        end_date,
        **kwargs
    ) -> OutlierResponseRoot:
        """Get Outlier Metrics by standard deviation  # noqa: E501

        Get outlier metrics by the specified metric type and date range  # noqa: E501
        This method makes a synchronous HTTP request. Returns the http data only

        Args:
            metric_type (str): Metric type
            start_date (str): Start date in the format YYYY-MM-DD
            end_date (str): End date in the format YYYY-MM-DD

        Keyword Args:
            region (str): The two character ISO country code of the trading region. EMEA is used for the European trading region. [optional]
            trader (str): Optionally specify a trader to filter by, Example : Ryan. [optional]
            deviation (float): Deviation. [optional] if omitted the server will use the default value of 2
            bin_scalar (int): Bin Scalar. [optional] if omitted the server will use the default value of 51
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            OutlierResponseRoot
                Response Object
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=False)
        kwargs['metric_type'] = \
            metric_type
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.get_outlier_metrics_standard_endpoint.call_with_http_info(**kwargs)

    def get_outlier_metrics_standard_with_http_info(
        self,
        metric_type,
        start_date,
        end_date,
        **kwargs
    ) -> typing.Tuple[OutlierResponseRoot, int, typing.MutableMapping]:
        """Get Outlier Metrics by standard deviation  # noqa: E501

        Get outlier metrics by the specified metric type and date range  # noqa: E501
        This method makes a synchronous HTTP request. Returns http data, http status and headers

        Args:
            metric_type (str): Metric type
            start_date (str): Start date in the format YYYY-MM-DD
            end_date (str): End date in the format YYYY-MM-DD

        Keyword Args:
            region (str): The two character ISO country code of the trading region. EMEA is used for the European trading region. [optional]
            trader (str): Optionally specify a trader to filter by, Example : Ryan. [optional]
            deviation (float): Deviation. [optional] if omitted the server will use the default value of 2
            bin_scalar (int): Bin Scalar. [optional] if omitted the server will use the default value of 51
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            OutlierResponseRoot
                Response Object
            int
                Http Status Code
            dict
                Dictionary of the response headers
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=False)
        kwargs['metric_type'] = \
            metric_type
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.get_outlier_metrics_standard_endpoint.call_with_http_info(**kwargs)

    def get_outlier_metrics_standard_async(
        self,
        metric_type,
        start_date,
        end_date,
        **kwargs
    ) -> "ApplyResult[OutlierResponseRoot]":
        """Get Outlier Metrics by standard deviation  # noqa: E501

        Get outlier metrics by the specified metric type and date range  # noqa: E501
        This method makes a asynchronous HTTP request. Returns the http data, wrapped in ApplyResult

        Args:
            metric_type (str): Metric type
            start_date (str): Start date in the format YYYY-MM-DD
            end_date (str): End date in the format YYYY-MM-DD

        Keyword Args:
            region (str): The two character ISO country code of the trading region. EMEA is used for the European trading region. [optional]
            trader (str): Optionally specify a trader to filter by, Example : Ryan. [optional]
            deviation (float): Deviation. [optional] if omitted the server will use the default value of 2
            bin_scalar (int): Bin Scalar. [optional] if omitted the server will use the default value of 51
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[OutlierResponseRoot]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=True)
        kwargs['metric_type'] = \
            metric_type
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.get_outlier_metrics_standard_endpoint.call_with_http_info(**kwargs)

    def get_outlier_metrics_standard_with_http_info_async(
        self,
        metric_type,
        start_date,
        end_date,
        **kwargs
    ) -> "ApplyResult[typing.Tuple[OutlierResponseRoot, int, typing.MutableMapping]]":
        """Get Outlier Metrics by standard deviation  # noqa: E501

        Get outlier metrics by the specified metric type and date range  # noqa: E501
        This method makes a asynchronous HTTP request. Returns http data, http status and headers, wrapped in ApplyResult

        Args:
            metric_type (str): Metric type
            start_date (str): Start date in the format YYYY-MM-DD
            end_date (str): End date in the format YYYY-MM-DD

        Keyword Args:
            region (str): The two character ISO country code of the trading region. EMEA is used for the European trading region. [optional]
            trader (str): Optionally specify a trader to filter by, Example : Ryan. [optional]
            deviation (float): Deviation. [optional] if omitted the server will use the default value of 2
            bin_scalar (int): Bin Scalar. [optional] if omitted the server will use the default value of 51
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[(OutlierResponseRoot, int, typing.Dict)]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=True)
        kwargs['metric_type'] = \
            metric_type
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.get_outlier_metrics_standard_endpoint.call_with_http_info(**kwargs)


