"""
    Best Execution Analytics for Smarter Trading (BEAST) API

    Enables clients to programmatically access the underlying data which powers the BEAST Liquidity Analytics (LA) and Transaction Cost Analysis (TCA) applications.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.BestExecutionAnalyticsforSmarterTradingBEAST.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.BestExecutionAnalyticsforSmarterTradingBEAST.exceptions import ApiAttributeError



class MultiDayBenchmarks(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            't_minus5_open_price': (float,),  # noqa: E501
            't_minus4_close_perf_bps': (float,),  # noqa: E501
            't_minus3_close_perf_bps': (float,),  # noqa: E501
            't_minus2_open_price': (float,),  # noqa: E501
            't_plus3_open_price': (float,),  # noqa: E501
            't_plus1_date_id': (str,),  # noqa: E501
            't_plus5_close_price': (float,),  # noqa: E501
            't_minus2_close_perf_bps': (float,),  # noqa: E501
            't_minus1_close_perf_bps': (float,),  # noqa: E501
            't_minus4_date_id': (str,),  # noqa: E501
            't_date_id': (str,),  # noqa: E501
            't_minus3_close_price': (float,),  # noqa: E501
            't_minus3_open_perf_bps': (float,),  # noqa: E501
            't_plus1_close_price': (float,),  # noqa: E501
            't_open_price': (float,),  # noqa: E501
            't_plus5_open_perf_bps': (float,),  # noqa: E501
            't_minus1_date_id': (str,),  # noqa: E501
            't_minus5_close_price': (float,),  # noqa: E501
            't_plus2_date_id': (str,),  # noqa: E501
            't_plus2_close_price': (float,),  # noqa: E501
            't_minus3_date_id': (str,),  # noqa: E501
            't_minus2_open_perf_bps': (float,),  # noqa: E501
            't_plus5_date_id': (str,),  # noqa: E501
            't_plus2_open_price': (float,),  # noqa: E501
            't_minus3_open_price': (float,),  # noqa: E501
            't_minus5_close_perf_bps': (float,),  # noqa: E501
            't_minus2_close_price': (float,),  # noqa: E501
            't_close_perf_bps': (float,),  # noqa: E501
            't_plus3_close_price': (float,),  # noqa: E501
            't_minus1_open_perf_bps': (float,),  # noqa: E501
            't_open_perf_bps': (float,),  # noqa: E501
            't_plus4_open_perf_bps': (float,),  # noqa: E501
            't_minus4_close_price': (float,),  # noqa: E501
            't_minus4_open_perf_bps': (float,),  # noqa: E501
            't_minus1_close_price': (float,),  # noqa: E501
            't_plus1_close_perf_bps': (float,),  # noqa: E501
            't_plus1_open_price': (float,),  # noqa: E501
            't_plus3_date_id': (str,),  # noqa: E501
            't_minus4_open_price': (float,),  # noqa: E501
            't_plus4_open_price': (float,),  # noqa: E501
            't_plus1_open_perf_bps': (float,),  # noqa: E501
            't_plus5_close_perf_bps': (float,),  # noqa: E501
            't_plus4_close_perf_bps': (float,),  # noqa: E501
            't_plus2_close_perf_bps': (float,),  # noqa: E501
            't_minus1_open_price': (float,),  # noqa: E501
            't_plus3_close_perf_bps': (float,),  # noqa: E501
            't_plus4_close_price': (float,),  # noqa: E501
            't_plus2_open_perf_bps': (float,),  # noqa: E501
            't_plus4_date_id': (str,),  # noqa: E501
            't_plus5_open_price': (float,),  # noqa: E501
            't_close_price': (float,),  # noqa: E501
            't_minus5_date_id': (str,),  # noqa: E501
            't_minus2_date_id': (str,),  # noqa: E501
            't_minus5_open_perf_bps': (float,),  # noqa: E501
            't_plus3_open_perf_bps': (float,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        't_minus5_open_price': 'tMinus5OpenPrice',  # noqa: E501
        't_minus4_close_perf_bps': 'tMinus4ClosePerfBps',  # noqa: E501
        't_minus3_close_perf_bps': 'tMinus3ClosePerfBps',  # noqa: E501
        't_minus2_open_price': 'tMinus2OpenPrice',  # noqa: E501
        't_plus3_open_price': 'tPlus3OpenPrice',  # noqa: E501
        't_plus1_date_id': 'tPlus1DateId',  # noqa: E501
        't_plus5_close_price': 'tPlus5ClosePrice',  # noqa: E501
        't_minus2_close_perf_bps': 'tMinus2ClosePerfBps',  # noqa: E501
        't_minus1_close_perf_bps': 'tMinus1ClosePerfBps',  # noqa: E501
        't_minus4_date_id': 'tMinus4DateId',  # noqa: E501
        't_date_id': 'tDateId',  # noqa: E501
        't_minus3_close_price': 'tMinus3ClosePrice',  # noqa: E501
        't_minus3_open_perf_bps': 'tMinus3OpenPerfBps',  # noqa: E501
        't_plus1_close_price': 'tPlus1ClosePrice',  # noqa: E501
        't_open_price': 'tOpenPrice',  # noqa: E501
        't_plus5_open_perf_bps': 'tPlus5OpenPerfBps',  # noqa: E501
        't_minus1_date_id': 'tMinus1DateId',  # noqa: E501
        't_minus5_close_price': 'tMinus5ClosePrice',  # noqa: E501
        't_plus2_date_id': 'tPlus2DateId',  # noqa: E501
        't_plus2_close_price': 'tPlus2ClosePrice',  # noqa: E501
        't_minus3_date_id': 'tMinus3DateId',  # noqa: E501
        't_minus2_open_perf_bps': 'tMinus2OpenPerfBps',  # noqa: E501
        't_plus5_date_id': 'tPlus5DateId',  # noqa: E501
        't_plus2_open_price': 'tPlus2OpenPrice',  # noqa: E501
        't_minus3_open_price': 'tMinus3OpenPrice',  # noqa: E501
        't_minus5_close_perf_bps': 'tMinus5ClosePerfBps',  # noqa: E501
        't_minus2_close_price': 'tMinus2ClosePrice',  # noqa: E501
        't_close_perf_bps': 'tClosePerfBps',  # noqa: E501
        't_plus3_close_price': 'tPlus3ClosePrice',  # noqa: E501
        't_minus1_open_perf_bps': 'tMinus1OpenPerfBps',  # noqa: E501
        't_open_perf_bps': 'tOpenPerfBps',  # noqa: E501
        't_plus4_open_perf_bps': 'tPlus4OpenPerfBps',  # noqa: E501
        't_minus4_close_price': 'tMinus4ClosePrice',  # noqa: E501
        't_minus4_open_perf_bps': 'tMinus4OpenPerfBps',  # noqa: E501
        't_minus1_close_price': 'tMinus1ClosePrice',  # noqa: E501
        't_plus1_close_perf_bps': 'tPlus1ClosePerfBps',  # noqa: E501
        't_plus1_open_price': 'tPlus1OpenPrice',  # noqa: E501
        't_plus3_date_id': 'tPlus3DateId',  # noqa: E501
        't_minus4_open_price': 'tMinus4OpenPrice',  # noqa: E501
        't_plus4_open_price': 'tPlus4OpenPrice',  # noqa: E501
        't_plus1_open_perf_bps': 'tPlus1OpenPerfBps',  # noqa: E501
        't_plus5_close_perf_bps': 'tPlus5ClosePerfBps',  # noqa: E501
        't_plus4_close_perf_bps': 'tPlus4ClosePerfBps',  # noqa: E501
        't_plus2_close_perf_bps': 'tPlus2ClosePerfBps',  # noqa: E501
        't_minus1_open_price': 'tMinus1OpenPrice',  # noqa: E501
        't_plus3_close_perf_bps': 'tPlus3ClosePerfBps',  # noqa: E501
        't_plus4_close_price': 'tPlus4ClosePrice',  # noqa: E501
        't_plus2_open_perf_bps': 'tPlus2OpenPerfBps',  # noqa: E501
        't_plus4_date_id': 'tPlus4DateId',  # noqa: E501
        't_plus5_open_price': 'tPlus5OpenPrice',  # noqa: E501
        't_close_price': 'tClosePrice',  # noqa: E501
        't_minus5_date_id': 'tMinus5DateId',  # noqa: E501
        't_minus2_date_id': 'tMinus2DateId',  # noqa: E501
        't_minus5_open_perf_bps': 'tMinus5OpenPerfBps',  # noqa: E501
        't_plus3_open_perf_bps': 'tPlus3OpenPerfBps',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """MultiDayBenchmarks - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            t_minus5_open_price (float): tMinus5OpenPrice. [optional]  # noqa: E501
            t_minus4_close_perf_bps (float): tMinus4ClosePerfBps. [optional]  # noqa: E501
            t_minus3_close_perf_bps (float): tMinus3ClosePerfBps. [optional]  # noqa: E501
            t_minus2_open_price (float): tMinus2OpenPrice. [optional]  # noqa: E501
            t_plus3_open_price (float): tPlus3OpenPrice. [optional]  # noqa: E501
            t_plus1_date_id (str): tPlus1DateId. [optional]  # noqa: E501
            t_plus5_close_price (float): tPlus5ClosePrice. [optional]  # noqa: E501
            t_minus2_close_perf_bps (float): tMinus2ClosePerfBps. [optional]  # noqa: E501
            t_minus1_close_perf_bps (float): tMinus1ClosePerfBps. [optional]  # noqa: E501
            t_minus4_date_id (str): tMinus4DateId. [optional]  # noqa: E501
            t_date_id (str): tDateId. [optional]  # noqa: E501
            t_minus3_close_price (float): tMinus3ClosePrice. [optional]  # noqa: E501
            t_minus3_open_perf_bps (float): tMinus3OpenPerfBps. [optional]  # noqa: E501
            t_plus1_close_price (float): tPlus1ClosePrice. [optional]  # noqa: E501
            t_open_price (float): tOpenPrice. [optional]  # noqa: E501
            t_plus5_open_perf_bps (float): tPlus5OpenPerfBps. [optional]  # noqa: E501
            t_minus1_date_id (str): tMinus1DateId. [optional]  # noqa: E501
            t_minus5_close_price (float): tMinus5ClosePrice. [optional]  # noqa: E501
            t_plus2_date_id (str): tPlus2DateId. [optional]  # noqa: E501
            t_plus2_close_price (float): tPlus2ClosePrice. [optional]  # noqa: E501
            t_minus3_date_id (str): tMinus3DateId. [optional]  # noqa: E501
            t_minus2_open_perf_bps (float): tMinus2OpenPerfBps. [optional]  # noqa: E501
            t_plus5_date_id (str): tPlus5DateId. [optional]  # noqa: E501
            t_plus2_open_price (float): tPlus2OpenPrice. [optional]  # noqa: E501
            t_minus3_open_price (float): tMinus3OpenPrice. [optional]  # noqa: E501
            t_minus5_close_perf_bps (float): tMinus5ClosePerfBps. [optional]  # noqa: E501
            t_minus2_close_price (float): tMinus2ClosePrice. [optional]  # noqa: E501
            t_close_perf_bps (float): tClosePerfBps. [optional]  # noqa: E501
            t_plus3_close_price (float): tPlus3ClosePrice. [optional]  # noqa: E501
            t_minus1_open_perf_bps (float): tMinus1OpenPerfBps. [optional]  # noqa: E501
            t_open_perf_bps (float): tOpenPerfBps. [optional]  # noqa: E501
            t_plus4_open_perf_bps (float): tPlus4OpenPerfBps. [optional]  # noqa: E501
            t_minus4_close_price (float): tMinus4ClosePrice. [optional]  # noqa: E501
            t_minus4_open_perf_bps (float): tMinus4OpenPerfBps. [optional]  # noqa: E501
            t_minus1_close_price (float): tMinus1ClosePrice. [optional]  # noqa: E501
            t_plus1_close_perf_bps (float): tPlus1ClosePerfBps. [optional]  # noqa: E501
            t_plus1_open_price (float): tPlus1OpenPrice. [optional]  # noqa: E501
            t_plus3_date_id (str): tPlus3DateId. [optional]  # noqa: E501
            t_minus4_open_price (float): tMinus4OpenPrice. [optional]  # noqa: E501
            t_plus4_open_price (float): tPlus4OpenPrice. [optional]  # noqa: E501
            t_plus1_open_perf_bps (float): tPlus1OpenPerfBps. [optional]  # noqa: E501
            t_plus5_close_perf_bps (float): tPlus5ClosePerfBps. [optional]  # noqa: E501
            t_plus4_close_perf_bps (float): tPlus4ClosePerfBps. [optional]  # noqa: E501
            t_plus2_close_perf_bps (float): tPlus2ClosePerfBps. [optional]  # noqa: E501
            t_minus1_open_price (float): tMinus1OpenPrice. [optional]  # noqa: E501
            t_plus3_close_perf_bps (float): tPlus3ClosePerfBps. [optional]  # noqa: E501
            t_plus4_close_price (float): tPlus4ClosePrice. [optional]  # noqa: E501
            t_plus2_open_perf_bps (float): tPlus2OpenPerfBps. [optional]  # noqa: E501
            t_plus4_date_id (str): tPlus4DateId. [optional]  # noqa: E501
            t_plus5_open_price (float): tPlus5OpenPrice. [optional]  # noqa: E501
            t_close_price (float): tClosePrice. [optional]  # noqa: E501
            t_minus5_date_id (str): tMinus5DateId. [optional]  # noqa: E501
            t_minus2_date_id (str): tMinus2DateId. [optional]  # noqa: E501
            t_minus5_open_perf_bps (float): tMinus5OpenPerfBps. [optional]  # noqa: E501
            t_plus3_open_perf_bps (float): tPlus3OpenPerfBps. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """MultiDayBenchmarks - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            t_minus5_open_price (float): tMinus5OpenPrice. [optional]  # noqa: E501
            t_minus4_close_perf_bps (float): tMinus4ClosePerfBps. [optional]  # noqa: E501
            t_minus3_close_perf_bps (float): tMinus3ClosePerfBps. [optional]  # noqa: E501
            t_minus2_open_price (float): tMinus2OpenPrice. [optional]  # noqa: E501
            t_plus3_open_price (float): tPlus3OpenPrice. [optional]  # noqa: E501
            t_plus1_date_id (str): tPlus1DateId. [optional]  # noqa: E501
            t_plus5_close_price (float): tPlus5ClosePrice. [optional]  # noqa: E501
            t_minus2_close_perf_bps (float): tMinus2ClosePerfBps. [optional]  # noqa: E501
            t_minus1_close_perf_bps (float): tMinus1ClosePerfBps. [optional]  # noqa: E501
            t_minus4_date_id (str): tMinus4DateId. [optional]  # noqa: E501
            t_date_id (str): tDateId. [optional]  # noqa: E501
            t_minus3_close_price (float): tMinus3ClosePrice. [optional]  # noqa: E501
            t_minus3_open_perf_bps (float): tMinus3OpenPerfBps. [optional]  # noqa: E501
            t_plus1_close_price (float): tPlus1ClosePrice. [optional]  # noqa: E501
            t_open_price (float): tOpenPrice. [optional]  # noqa: E501
            t_plus5_open_perf_bps (float): tPlus5OpenPerfBps. [optional]  # noqa: E501
            t_minus1_date_id (str): tMinus1DateId. [optional]  # noqa: E501
            t_minus5_close_price (float): tMinus5ClosePrice. [optional]  # noqa: E501
            t_plus2_date_id (str): tPlus2DateId. [optional]  # noqa: E501
            t_plus2_close_price (float): tPlus2ClosePrice. [optional]  # noqa: E501
            t_minus3_date_id (str): tMinus3DateId. [optional]  # noqa: E501
            t_minus2_open_perf_bps (float): tMinus2OpenPerfBps. [optional]  # noqa: E501
            t_plus5_date_id (str): tPlus5DateId. [optional]  # noqa: E501
            t_plus2_open_price (float): tPlus2OpenPrice. [optional]  # noqa: E501
            t_minus3_open_price (float): tMinus3OpenPrice. [optional]  # noqa: E501
            t_minus5_close_perf_bps (float): tMinus5ClosePerfBps. [optional]  # noqa: E501
            t_minus2_close_price (float): tMinus2ClosePrice. [optional]  # noqa: E501
            t_close_perf_bps (float): tClosePerfBps. [optional]  # noqa: E501
            t_plus3_close_price (float): tPlus3ClosePrice. [optional]  # noqa: E501
            t_minus1_open_perf_bps (float): tMinus1OpenPerfBps. [optional]  # noqa: E501
            t_open_perf_bps (float): tOpenPerfBps. [optional]  # noqa: E501
            t_plus4_open_perf_bps (float): tPlus4OpenPerfBps. [optional]  # noqa: E501
            t_minus4_close_price (float): tMinus4ClosePrice. [optional]  # noqa: E501
            t_minus4_open_perf_bps (float): tMinus4OpenPerfBps. [optional]  # noqa: E501
            t_minus1_close_price (float): tMinus1ClosePrice. [optional]  # noqa: E501
            t_plus1_close_perf_bps (float): tPlus1ClosePerfBps. [optional]  # noqa: E501
            t_plus1_open_price (float): tPlus1OpenPrice. [optional]  # noqa: E501
            t_plus3_date_id (str): tPlus3DateId. [optional]  # noqa: E501
            t_minus4_open_price (float): tMinus4OpenPrice. [optional]  # noqa: E501
            t_plus4_open_price (float): tPlus4OpenPrice. [optional]  # noqa: E501
            t_plus1_open_perf_bps (float): tPlus1OpenPerfBps. [optional]  # noqa: E501
            t_plus5_close_perf_bps (float): tPlus5ClosePerfBps. [optional]  # noqa: E501
            t_plus4_close_perf_bps (float): tPlus4ClosePerfBps. [optional]  # noqa: E501
            t_plus2_close_perf_bps (float): tPlus2ClosePerfBps. [optional]  # noqa: E501
            t_minus1_open_price (float): tMinus1OpenPrice. [optional]  # noqa: E501
            t_plus3_close_perf_bps (float): tPlus3ClosePerfBps. [optional]  # noqa: E501
            t_plus4_close_price (float): tPlus4ClosePrice. [optional]  # noqa: E501
            t_plus2_open_perf_bps (float): tPlus2OpenPerfBps. [optional]  # noqa: E501
            t_plus4_date_id (str): tPlus4DateId. [optional]  # noqa: E501
            t_plus5_open_price (float): tPlus5OpenPrice. [optional]  # noqa: E501
            t_close_price (float): tClosePrice. [optional]  # noqa: E501
            t_minus5_date_id (str): tMinus5DateId. [optional]  # noqa: E501
            t_minus2_date_id (str): tMinus2DateId. [optional]  # noqa: E501
            t_minus5_open_perf_bps (float): tMinus5OpenPerfBps. [optional]  # noqa: E501
            t_plus3_open_perf_bps (float): tPlus3OpenPerfBps. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
