"""
    Best Execution Analytics for Smarter Trading (BEAST) API

    Enables clients to programmatically access the underlying data which powers the BEAST Liquidity Analytics (LA) and Transaction Cost Analysis (TCA) applications.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.BestExecutionAnalyticsforSmarterTradingBEAST.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.BestExecutionAnalyticsforSmarterTradingBEAST.exceptions import ApiAttributeError



class OutputStrategyBinData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'bin_time': (str,),  # noqa: E501
            'security_id': (str,),  # noqa: E501
            'country': (str,),  # noqa: E501
            'currency': (str,),  # noqa: E501
            'date_id': (str,),  # noqa: E501
            'total_cost': (float,),  # noqa: E501
            'spread_cost': (float,),  # noqa: E501
            'liquidity_cost': (float,),  # noqa: E501
            'confidence_interval': (float,),  # noqa: E501
            'signal_cost': (float,),  # noqa: E501
            'capped_price': (float,),  # noqa: E501
            'reversion_price': (float,),  # noqa: E501
            'stock_price': (float,),  # noqa: E501
            'arrival_mid': (float,),  # noqa: E501
            'strategy_volume': (float,),  # noqa: E501
            'part_rate': (float,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'bin_time': 'binTime',  # noqa: E501
        'security_id': 'securityId',  # noqa: E501
        'country': 'country',  # noqa: E501
        'currency': 'currency',  # noqa: E501
        'date_id': 'dateId',  # noqa: E501
        'total_cost': 'totalCost',  # noqa: E501
        'spread_cost': 'spreadCost',  # noqa: E501
        'liquidity_cost': 'liquidityCost',  # noqa: E501
        'confidence_interval': 'confidenceInterval',  # noqa: E501
        'signal_cost': 'signalCost',  # noqa: E501
        'capped_price': 'cappedPrice',  # noqa: E501
        'reversion_price': 'reversionPrice',  # noqa: E501
        'stock_price': 'stockPrice',  # noqa: E501
        'arrival_mid': 'arrivalMid',  # noqa: E501
        'strategy_volume': 'strategyVolume',  # noqa: E501
        'part_rate': 'partRate',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """OutputStrategyBinData - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bin_time (str): The time in UTC of the start of the bin. Each bin has a duration of 5 minutes. [optional]  # noqa: E501
            security_id (str): Security Id. [optional]  # noqa: E501
            country (str): The two character ISO country code. [optional]  # noqa: E501
            currency (str): Currency. [optional]  # noqa: E501
            date_id (str): Date Id. [optional]  # noqa: E501
            total_cost (float): Total Cost. [optional]  # noqa: E501
            spread_cost (float): Spread Cost. [optional]  # noqa: E501
            liquidity_cost (float): Liquidity Cost. [optional]  # noqa: E501
            confidence_interval (float): Confidence Interval. [optional]  # noqa: E501
            signal_cost (float): Signal Cost. [optional]  # noqa: E501
            capped_price (float): Capped Price. [optional]  # noqa: E501
            reversion_price (float): Reversion Price. [optional]  # noqa: E501
            stock_price (float): Stock Price. [optional]  # noqa: E501
            arrival_mid (float): Arrival Mid. [optional]  # noqa: E501
            strategy_volume (float): Strategy Volume. [optional]  # noqa: E501
            part_rate (float): Part Rate. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """OutputStrategyBinData - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            bin_time (str): The time in UTC of the start of the bin. Each bin has a duration of 5 minutes. [optional]  # noqa: E501
            security_id (str): Security Id. [optional]  # noqa: E501
            country (str): The two character ISO country code. [optional]  # noqa: E501
            currency (str): Currency. [optional]  # noqa: E501
            date_id (str): Date Id. [optional]  # noqa: E501
            total_cost (float): Total Cost. [optional]  # noqa: E501
            spread_cost (float): Spread Cost. [optional]  # noqa: E501
            liquidity_cost (float): Liquidity Cost. [optional]  # noqa: E501
            confidence_interval (float): Confidence Interval. [optional]  # noqa: E501
            signal_cost (float): Signal Cost. [optional]  # noqa: E501
            capped_price (float): Capped Price. [optional]  # noqa: E501
            reversion_price (float): Reversion Price. [optional]  # noqa: E501
            stock_price (float): Stock Price. [optional]  # noqa: E501
            arrival_mid (float): Arrival Mid. [optional]  # noqa: E501
            strategy_volume (float): Strategy Volume. [optional]  # noqa: E501
            part_rate (float): Part Rate. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
